/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.awt;

import net.hizlab.kagetaka.awt.image.OffscreenObserver;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.SystemColor;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;

/**
 * ᡼դΥɽ饹Ǥ
 * ΥܥϡˤꣴĤΥ᡼̾С̵ˤѤޤ
 * ΤᡢĤξ֤٤ƤΥ᡼ꤹˡȡ
 * Ĥξ֡̾ˤΥ᡼뤤ϲлΥ᡼ꤷ
 * 줫ꤵƤʤ¾ξ֤ <code>ImageButton</code> 
 * Фˡޤ
 * <p>
 * ޤ<code>setHotspot</code> ᥽åɤǡ
 * ֥˥塼ѤΥ᡼ɲä뤳Ȥޤ
 * <p>
 * Ĥξ֤٤ƤΥ᡼ꤷƤ硢
 * <code>setHotspot</code> ᥽åɤǤϡĤΥѥϿ
 * ɬפޤΥ᥽åɤϿĤΰΰ
 * ޥưȡ֥˥塼ѤưԤޤ
 * Ĥξ֤Υ᡼Ƥ硢<code>setHotspot</code> ᥽åɤϡ
 * ĤΰΥѥϿɬפޤξ硢ۥåȥݥåѤ
 * ᡼ϡ̾Υ᡼α¦ɲäޤ
 * <p>
 * Ĥξ֤Υ᡼Ƥ硢᡼Ȱɽʸ
 * Ǥޤξ硢᡼α¦ǥۥåȥݥåȤ꺸¦
 * ʸɽޤ
 * 
 * @kagetaka.bugs ľ󲽤ϡꥹʤ¸ʤޤ
 * 
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.1 $
 */
public class ImageLabel
	extends Component
{
	private static final int SPACE = 2;
	
	/** @serial ᡼ꥨ */
	private ImageCreatorComponent icc = new ImageCreatorComponent(this);
	
	/** @serial ̾᡼ */
	private Image     image;
	/** @serial ̾磻᡼ */
	private Dimension size = new Dimension(SPACE, SPACE);
	/** @serial 褬ɬפ */
	private boolean   refresh;
	
	/** @serial ե꡼ */
	private Image    offScreen;
	/** @serial ե꡼󥰥եå */
	private Graphics og;
	/** @serial ե꡼å */
	private Object   ogLock = new Object();
	/** @serial ե꡼󥤥᡼ */
	private OffscreenObserver oo;
	
	/**
	 * ꤵ줿᡼̵󥹥󥹤ޤ
	 */
	public ImageLabel()
	{
		this(null);
	}
	
	/**
	 * ꤵ줿᡼򸵤ˡ󥹥󥹤ޤ
	 * 
	 * @param     image ᡼
	 */
	public ImageLabel(Image image)
	{
		setImage(image);
		
		addComponentListener(
			new ComponentAdapter()
			{
				/** ѹ */
				public void componentResized(ComponentEvent e)
				{
					synchronized (ogLock) {
						if (offScreen != null) {
							if (oo != null) { oo.dispose(); oo = null; }
							og.dispose();
							offScreen.flush();
						}
						
						Dimension nowSize = getSize();
						if (nowSize.width == 0 || nowSize.height == 0) {
							offScreen = null;
							og        = null;
						} else {
							offScreen = createImage(nowSize.width, nowSize.height);
							og        = offScreen.getGraphics();
							refresh = true;
							repaint();
						}
					}
				}
			}
		);
	}
	
	/**
	 * 侩֤ޤ
	 * 
	 * @return    侩
	 */
	public Dimension getPreferredSize()
	{
		return new Dimension(size);
	}
	
	/**
	 * Ǿ֤ޤ
	 * 
	 * @return    Ǿ
	 */
	public Dimension getMinimumSize()
	{
		return getPreferredSize();
	}
	
	/**
	 * ᡼֤ޤ
	 * 
	 * @return    ᡼
	 */
	public Image getImage()
	{
		return image;
	}
	
	/**
	 * ᡼ꤷޤ
	 * 
	 * @param     image ᡼
	 */
	public void setImage(Image image)
	{
		synchronized (size) {
			Dimension old = new Dimension(size);
			
			if (image != null && ImageUtils.load(image, this)) {
				size.width  = image.getWidth (this) + SPACE * 2;
				size.height = image.getHeight(this) + SPACE * 2;
			} else {
				image = null;
				size.width = size.height = SPACE * 2;
			}
			
			this.image   = image;
			this.refresh = true;
			
			// ȥ㤦Τߺƥ쥤оݤˤ
			if (!old.equals(size))
				invalidate();
			
			repaint();
		}
	}
	
	/**
	 * ̤򥢥åץǡȤޤ
	 * 
	 * @param     g եå
	 */
	public void update(Graphics g)
	{
		paint(g);
	}
	
	/**
	 * ᡼ºݤ褷ޤ
	 * 
	 * @param     g եå
	 */
	public void paint(Graphics g)
	{
		synchronized (ogLock) {
			synchronized (size) {
				if (refresh)
					refresh();
			}
			
			if (offScreen != null)
				g.drawImage(offScreen, 0, 0, this);
		}
	}
	
	/** ߤΥơˤä֤˺ */
	private void refresh()
	{
		if (offScreen == null)
			return;
		
		if (oo != null) { oo.dispose(); oo = null; }
		
		Dimension size = getSize();
		
		og.setColor(getBackground());
		og.fillRect(0, 0, size.width, size.height);
		
		// Ȥ
		og.setColor(SystemColor.controlShadow);
		og.drawLine(0, 0, size.width - 1,  0);
		og.drawLine(0, 0, 0, size.height - 1);
		og.setColor(SystemColor.controlDkShadow);
		og.drawLine(1, 1, size.width - 2,  1);
		og.drawLine(1, 1, 1, size.height - 2);
		og.setColor(SystemColor.controlHighlight);
		og.drawLine(size.width - 2,  2, size.width - 2, size.height - 2);
		og.drawLine(2, size.height - 2, size.width - 2, size.height - 2);
		og.setColor(SystemColor.controlLtHighlight);
		og.drawLine(size.width - 1,  1, size.width - 1, size.height - 1);
		og.drawLine(1, size.height - 1, size.width - 1, size.height - 1);
		
		if (image != null) {
			int x = (size.width  - this.size.width ) / 2 + SPACE;
			int y = (size.height - this.size.height) / 2 + SPACE;
			oo = new OffscreenObserver(this, og, x, y, null);
			og.drawImage(image, x, y, oo);
		}
		
		refresh = false;
	}
}
