/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.rendering;

import java.io.IOException;
import java.net.URLConnection;

/**
 * ³åԥ󥰤륯饹Ǥ
 * ΥåѡѤ뤳Ȥˤꡢ³ˤ⤫餺
 * ߤФ᤯ȿǤޤ
 * 
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.1 $
 */
class ConnectWrapper
	extends Thread
{
	private HawkContext          context;
	private Request              request;
	private URLConnection        connection;
	private IOException          ioException;
	private InterruptedException interruptedException;
	private RuntimeException     runtimeException;
	private Error                error;
	
	/**
	 * ͥޤ
	 * 
	 * @param     request ꥯ
	 * 
	 * @return    URL ͥ
	 * 
	 * @exception IOException IO 顼ȯ
	 * @exception InterruptedException ߤȯ
	 */
	static URLConnection getURLConnection(HawkContext context, Request request)
		throws IOException, InterruptedException
	{
		ConnectWrapper cw = new ConnectWrapper(context, request);
		cw.start();
		
		try {
			cw.join();
		} catch (InterruptedException e) {
			cw.interrupt();
			throw e;
		}
		
		if (cw.connection           != null) return cw.connection;
		if (cw.ioException          != null) throw  cw.ioException;
		if (cw.interruptedException != null) throw  cw.interruptedException;
		if (cw.runtimeException     != null) throw  cw.runtimeException;
		if (cw.error                != null) throw  cw.error;
		
		return null;
	}
	
	/** 󥹥󥹤 */
	private ConnectWrapper(HawkContext context, Request request)
	{
		this.context = context;
		this.request = request;
	}
	
	/**  */
	public void run()
	{
		try {
			connection = context.getURLConnection(request);
		} catch (IOException e) {
			ioException = e;
		} catch (InterruptedException e) {
			interruptedException = e;
		} catch (RuntimeException e) {
			runtimeException = e;
		} catch (Error e) {
			error = e;
		}
	}
}
